3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
11 export LANG LC_ALL PAGER TZ
18 unset COMMIT_AUTHOR_EMAIL
19 unset COMMIT_AUTHOR_NAME
21 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
23 GIT_AUTHOR_EMAIL=author@example.com
24 GIT_AUTHOR_NAME='A U Thor'
25 unset GIT_COMMITTER_DATE
26 GIT_COMMITTER_EMAIL=committer@example.com
27 GIT_COMMITTER_NAME='C O Mitter'
31 unset GIT_EXTERNAL_DIFF
33 unset GIT_OBJECT_DIRECTORY
34 unset SHA1_FILE_DIRECTORIES
35 unset SHA1_FILE_DIRECTORY
37 export GIT_MERGE_VERBOSITY
38 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
39 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
42 # Protect ourselves from common misconfiguration to export
43 # CDPATH into the environment
46 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
48 echo "* warning: Some tests will not work if GIT_TRACE" \
49 "is set as to trace on STDERR ! *"
50 echo "* warning: Please set GIT_TRACE to something" \
51 "other than 1, 2 or true ! *"
55 # Each test should start with something like this, after copyright notices:
57 # test_description='Description of this test...
58 # This test checks if command xyzzy does the right thing...
62 [ "x$TERM" != "xdumb" ] &&
64 tput bold >/dev/null 2>&1 &&
65 tput setaf 1 >/dev/null 2>&1 &&
66 tput sgr0 >/dev/null 2>&1 &&
72 -d|--d|--de|--deb|--debu|--debug)
74 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
76 -h|--h|--he|--hel|--help)
78 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
80 -q|--q|--qu|--qui|--quie|--quiet)
92 if test -n "$color"; then
95 error) tput bold; tput setaf 1;; # bold red
96 skip) tput bold; tput setaf 2;; # bold green
97 pass) tput setaf 2;; # green
98 info) tput setaf 3;; # brown
99 *) test -n "$quiet" && return;;
107 test -z "$1" && test -n "$quiet" && return
114 say_color error "error: $*"
123 test "${test_description}" != "" ||
124 error "Test script did not set test_description."
126 if test "$help" = "t"
128 echo "$test_description"
133 if test "$verbose" = "t"
137 exec 4>/dev/null 3>/dev/null
143 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
146 if test -z "${test_tick+set}"
150 test_tick=$(($test_tick + 60))
152 GIT_COMMITTER_DATE="$test_tick -0700"
153 GIT_AUTHOR_DATE="$test_tick -0700"
154 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
157 # You are not expected to call test_ok_ and test_failure_ directly, use
158 # the text_expect_* functions instead.
161 test_count=$(expr "$test_count" + 1)
162 say_color "" " ok $test_count: $@"
166 test_count=$(expr "$test_count" + 1)
167 test_failure=$(expr "$test_failure" + 1);
168 say_color error "FAIL $test_count: $1"
170 echo "$@" | sed -e 's/^/ /'
171 test "$immediate" = "" || { trap - exit; exit 1; }
176 test "$debug" = "" || eval "$1"
186 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
187 this_test="$this_test.$(expr "$test_count" + 1)"
189 for skp in $GIT_SKIP_TESTS
198 say_color skip >&3 "skipping test: $@"
199 test_count=$(expr "$test_count" + 1)
200 say_color skip "skip $test_count: $1"
209 test_expect_failure () {
211 error "bug in the test script: not 2 parameters to test-expect-failure"
214 say >&3 "expecting failure: $2"
216 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
226 test_expect_success () {
228 error "bug in the test script: not 2 parameters to test-expect-success"
231 say >&3 "expecting success: $2"
233 if [ "$?" = 0 -a "$eval_ret" = 0 ]
243 test_expect_code () {
245 error "bug in the test script: not 3 parameters to test-expect-code"
248 say >&3 "expecting exit code $1: $3"
250 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
260 # Most tests can use the created repository, but some amy need to create more.
261 # Usage: test_create_repo <directory>
262 test_create_repo () {
264 error "bug in the test script: not 1 parameter to test-create-repo"
268 cd "$repo" || error "Cannot setup test environment"
269 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
270 error "cannot run git init -- have you built things yet?"
271 mv .git/hooks .git/hooks-disabled
277 case "$test_failure" in
280 # cd .. && rm -fr trash
281 # but that means we forbid any tests that use their own
282 # subdirectory from calling test_done without coming back
283 # to where they started from.
284 # The Makefile provided will clean this test area so
285 # we will leave things as they are.
287 say_color pass "passed all $test_count test(s)"
291 say_color error "failed $test_failure among $test_count test(s)"
297 # Test the binaries we have just built. The tests are kept in
298 # t/ subdirectory and are run in trash subdirectory.
300 GIT_EXEC_PATH=$(pwd)/..
301 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
302 GIT_CONFIG=.git/config
303 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
305 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
307 test -d ../templates/blt || {
308 error "You haven't built things yet, have you?"
311 if ! test -x ../test-chmtime; then
312 echo >&2 'You need to build test-chmtime:'
313 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
320 test_create_repo $test
323 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
324 for skp in $GIT_SKIP_TESTS
327 for skp in $GIT_SKIP_TESTS
336 say_color skip >&3 "skipping test $this_test altogether"
337 say_color skip "skip all tests in $this_test"